#include "tcpip.h"

struct realm *icmp_realm;

struct icmp_head *icmprules=NULL;
unsigned int num_icmp_head=0;
unsigned int num_icmp_rules=0;

void icmp_match(struct packet *p, unsigned int l)
{
	return;
}

int icmp_commit(struct rule *r)
{
	return 0;
}

struct proto icmp_p=init_proto_ex("icmp", icmp_decode, icmp_dprint);
struct proto_req icmp_r[]={
	proto_request("ipv4", 1),
	null_request()
};

int icmp_dprint(struct layer *l, char *buf, int buflen)
{
	return snprintf(buf, buflen,
		"TYPE=%u CODE=%u",
		l->h.icmp->type,
		l->h.icmp->code);
}

int icmp_decode(struct packet *p)
{
	struct proto_child *pc;
	struct layer *l=&p->layer[p->llen-1];
	unsigned long icmpid;
	
	if ( p->llen >= PKT_LAYERS ) return 0;
	
	if ( (p->layer[p->llen].h.raw=
		l->h.raw+sizeof(pkt_icmphdr_t)) 
		>= p->end ) return 0;

	/* Might look odd but we just combine the type
	 * and code in order to make an ID for a child
	 * protocol */
	icmpid=(l->h.icmp->type<<8 | l->h.icmp->code);
	
	for(pc=l->proto->children; pc; pc=pc->next)
	{
		if ( icmpid == pc->id ) {
			p->layer[p->llen++].proto=pc->proto;
			return pc->proto->decode(p);
		}
	}

	p->layer[p->llen++].proto=NULL;
	return 0;
}
