#ifndef __MATCHER_HEADER_INCLUDED__
#define __MATCHER_HEADER_INCLUDED__

/* Cleanup said data structure */
typedef void(*proc_match_cleanup)(void *);

/* Compare two private data structures */
#define MCMP_DIFFER 0
#define MCMP_IDENTICAL 1
typedef int(*proc_match_compare)(void *, void *);

/* match a packet against private data */
typedef int(*proc_match_match)(struct packet *, void *, unsigned int, int);

/* Takes a parsed token and creates a private data structure */
typedef proc_match_match(*proc_match_validate)(char *, void **);

/* The matcher structure */
struct matcher {
	struct matcher		*next;
	char			*name;
	proc_match_compare	compare;
	proc_match_validate	validate;
	proc_match_cleanup	cleanup;
};

#ifndef __PLUGIN__
struct matcher *matcher_find(char *);
int matcher_add(char *,
	proc_match_validate,
	proc_match_compare,
	proc_match_cleanup);
#else
typedef struct matcher *(*proc_matcher_find)(char *);
typedef int (*proc_matcher_add)(char *,
	proc_match_validate,
	proc_match_compare,
	proc_match_cleanup);
#endif

#endif /* __MATCHER_HEADER_INCLUDED__ */
